<template>
	<!-- <div class="form-container"> -->
		<el-form ref="form" :model="model" :rules="rules" @submit.native.prevent
			class="height-100" :size="small ? 'small' :'medium'" 	label-width="150px" 
		>
			<el-main class="form-main" :style="{height: !footer ? '100%' : ''}">
				<slot :form="model"></slot>
			</el-main>
			<el-footer v-if="footer">
				<el-row type="flex"  justify="end">
					<el-col >
						<slot name="footer" :form="model" :submit="onSubmit" :validate="validate" />
						<template v-if="!hideButtons">
							<el-button type="primary" @click="onSubmit">Aplicar</el-button>
						</template>
					</el-col>
				</el-row>
			</el-footer>
		</el-form>
	<!-- </div> -->
</template>
<script>
export default {
	props:{
		value:{
			type:Object,
			default(){
				return {}
			}
		},
		/**
		 * Indica que no se deben mostrar los botones aceptar y cancelar del formulario
		 * Los métodos de aceptar y cancelar se deben manejar fuera del formulario
		 */
		hideButtons: Boolean,

		/**
		 * Indica que el formulario  posee footer
		 * Si se establece en bool, el formulario contendrá un footer con los botones
		 */
		footer: {
			type: Boolean,
			default: true,
		},

		/**
		 * Título del Formulario 
		 * */
		title: String,

		/**
		 * Indica si los componentes del formulario deben tener un tamaño pequeño
		 * Util para formularios embebidos
		 */
		small: Boolean,

		/**
		 * Indica que no se debe emitir un evento input cuando se modifica un campo del formulario
		 * Si se especifica esta opción, sólo se emitirá el evento @submit cuando se presione la acción submit
		 */
		noInputEvent: Boolean,

		/** Lista de reglas a aplicar al formulario antes del submit*/
		rules:{
			type: Object,
			default() {
				return {}
			}

		}

	},
	created(){
		},
	watch:{
		value:{
			immediate: true,
			deep: true,
			handler(value) {
				this.preventEmitInput = true
				this.model = Object.assign({}, value);
				// this.model = JSON.parse(JSON.stringify(value))
			}
		},
		model:{
			handler() {
				if(this.preventEmitInput || this.noInputEvent) {
					this.preventEmitInput = false
					return
				}
				this.$emit('input', this.model)
			},
			deep: true,
		}
	},
	computed:{

	},
	methods: {
		/**
		 * llama al método validate del formulario
		 */
		validate() {
			return this.$refs.form.validate()
		},
		async onSubmit() {
			// console.log(this.model)
			// if(await this.validate()) {
				// }
			this.validate().then(()=>{
					this.$emit('submit', this.model)
			}).catch(()=>{
				this.$message({
					type: 'error',
					showClose: true,
					message: 'Por favor, complete los campos requeridos'
				});
			})
		},
		onCancel() {
			this.$emit('cancel', this.model)
		}
	},
	data(){
		return {
			model:{},
			preventEmitInput: false,
		}
	}
}
</script>
<style scoped>
.height-100 {
	height: 100%;
}

.form-main {
	height: calc(100% - 64px);
	padding: 0;
}

</style>